@echo off
::
:: Add/remove "LDLS Administrator" permissions
::
:: Usage:  Permissions [/r] [Username]
:: /r will remove "LDLS Admin" rights
::
::  Windows XP/2k and Vista/Win7
::  D. Hooton April 2009
:: 

color 17
:: default to Add for current user
set Perm=A
set USERID=%USERNAME%

If %1!==!  (
   goto Askperm
)

If /i %1==/r (
   set Perm=R
   if %2!==! (
      set USERID=%USERNAME%
   ) else (
      set USERID=%~2
   )
) else (
   set USERID=%~1
)
goto Setperm

:::::::::::::::::::::::::
:: Interactive Dialogue
:::::::::::::::::::::::::
:Askperm

echo.
set /P "USERID=Enter Username [%USERNAME%] "
set USERID=%USERID:"=%
echo.
set /P "Perm=Remove(R) or Add(A) access? [A] "

:::::::::::::::::::::
:: Set Permissions
:::::::::::::::::::::
:Setperm

Call GetPaths -i
:: sets Libronix & Vista variables
set Common=%Libronix%\Common
set LDLSAdmn="%Libronix%\System\LDLSAdmn"

echo.

if /i %Perm%==R goto Remove 

Call :AddPerm "%Common%"
If %Errorset% EQU False (
   echo LDLS Admin permissions granted to %USERID%
)
goto Exit


:Remove
Call :DelPerm "%Common%"
If %Errorset% EQU False (
   echo LDLS Admin permissions removed for %USERID%
)
goto Exit


::::::::::::::::::::::::::::::::::::
:: Routine to add permissions
::::::::::::::::::::::::::::::::::::
:AddPerm

set Errorset=False

:: Grant Libronix Admin permissions

%LDLSAdmn% /s /a "%USERID%" 2>nul
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem granting LDLS permissions for %USERID%
   goto :EOF
)

::  Add Permissions for Common

rem Check for NTFS file system
CACLS %1 > nul
If %Errorlevel% EQU 1 (
   rem FAT file system
   goto :EOF
)
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem granting access to Common for %USERID%
   goto :EOF
)

:: ICACLS on Vista has flexible inheritable permissions unlike CACLS on older systems
:: ICACLS /grant:r and CACLS /P replace existing ACE's

If %Vista%==0  CACLS %1 /T /E /P "%USERID%":C > nul
If %Vista%==1 ICACLS %1 /grant:r "%USERID%":M "%USERID%":(OI)(CI)(IO)(DE,GR,GW,X) > nul
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem granting access to Common for %USERID%
)
goto :EOF


:::::::::::::::::::::::::::::::::::::::
:: Routine to Remove permissions
:::::::::::::::::::::::::::::::::::::::
:DelPerm

set Errorset=False

:: remove Libronix Admin permissions

%LDLSAdmn% /s /d "%USERID%" 2>nul
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem removing LDLS permissions for %USERID%
   goto :EOF
)

::  Remove Permissions for Common

rem Check for NTFS file system
CACLS %1 > nul
If %Errorlevel% EQU 1 (
   rem FAT file system
   goto :EOF
)
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem removing access to Common for %USERID%
   goto :EOF
)

:: Remove explicit granted permissions

If %Vista%==1 ( 
   ICACLS %1 /remove:g "%USERID%" /T > nul
) else (
   CACLS %1 /T /E /R "%USERID%" > nul
)
If %Errorlevel% NEQ 0 (
   set Errorset=True
   echo ERROR: problem removing access to Common for %USERID%
)
goto :EOF


:Exit
echo.
ECHO Press any key to finish...
PAUSE >nul
